// Purpose: Confirm 16-bit Timer1 in Fast PWM Mode to drive HTX500 Servo
// Reference A: K. Shirriff, http://www.righto.com/2009/07/secrets-of-arduino-pwm.html
// Reference B: HXT500 Micro 9g: http://tdiy.weebly.com/servo-motors.html
// Reference C: ATmega328P Datasheet (Section 15.9.3): http://mail.rsgc.on.ca/~cdarcy/Datasheets/ATMEGA328P.pdf
// Reference D: AVR Timer Calculator: https://www.easycalculation.com/engineering/electrical/avr-timer-calculator.php
// SIGNAL REQUIREMENTS:
// Period: 20ms > Frequency: 50Hz
// High: 0 Deg:1ms, 90 Deg:1.5ms, 180 Deg:2ms (Duty Cycle Range: 5% to 10%)
// PRESCALE CONSTANTS:
uint8_t clkDiv1 = 1 << CS10;
uint8_t clkDiv8 = 1 << CS11;
uint8_t clkDiv64 = 1 << CS11 | 1 << CS10;
uint8_t clkDiv256 = 1 << CS12;
uint8_t clkDiv1024 = 1 << CS12 | 1 << CS10;

// D'Arcy Excel Sheet: http://darcy.rsgc.on.ca/ACES/TEI4M/FastPWMOnTimer1.xlsx
// Hmmm....The values of 4 and 38 resulted from trial and error....
volatile uint8_t lowerLimit = 4;  //close to 0 degrees
volatile uint8_t upperLimit = 38; //close to 180 degrees
volatile uint8_t hornSpeed = 6; //# of TOPs reached before changing angle (duty cycle) in OCR1B
volatile uint8_t ovfCount = 0;

// Timer1 Output Compare triggered on TCNT1 == TOP
ISR(TIMER1_COMPA_vect) {
  // adjust hornSpeed limit as required to affect speed or rotation...

}

int main() {
  // Suspend interrupts

  // Configure for Fast PWM

  // Set prescaler and additional WGM bits for Fast PWM

  // Define TOP (See D'Arcy Excel worksheet)

  // Enable Output Compare for Timer 1 interrupt

  // Declare related peripheral pin(s) output

  // Enable Global Interrupt

  // Stand down and admire your engineering
  while (1);

}
